diff --git a/target/linux/mvebu/image/cortex-a72.mk b/target/linux/mvebu/image/cortex-a72.mk
index 6abee2d8b9..a7a4d7c2e7 100644
--- a/target/linux/mvebu/image/cortex-a72.mk
+++ b/target/linux/mvebu/image/cortex-a72.mk
@@ -1,14 +1,11 @@
-define Device/marvell_macchiatobin
+define Device/marvell_armada7040-db
   $(call Device/Default-arm64)
-  DEVICE_VENDOR := SolidRun
-  DEVICE_MODEL := MACCHIATObin
-  DEVICE_ALT0_VENDOR := SolidRun
-  DEVICE_ALT0_MODEL := Armada 8040 Community Board
-  DEVICE_PACKAGES += kmod-i2c-core kmod-i2c-mux kmod-i2c-mux-pca954x
-  DEVICE_DTS := armada-8040-mcbin
-  SUPPORTED_DEVICES := marvell,armada8040-mcbin
+  DEVICE_VENDOR := Marvell
+  DEVICE_MODEL := Armada 7040 Development Board
+  DEVICE_DTS := armada-7040-db
+  IMAGE/sdcard.img.gz := boot-img-ext4 | sdcard-img-ext4 | gzip | append-metadata
 endef
-TARGET_DEVICES += marvell_macchiatobin
+TARGET_DEVICES += marvell_armada7040-db
 
 define Device/marvell_armada8040-db
   $(call Device/Default-arm64)
@@ -19,11 +16,14 @@ define Device/marvell_armada8040-db
 endef
 TARGET_DEVICES += marvell_armada8040-db
 
-define Device/marvell_armada7040-db
+define Device/marvell_macchiatobin
   $(call Device/Default-arm64)
-  DEVICE_VENDOR := Marvell
-  DEVICE_MODEL := Armada 7040 Development Board
-  DEVICE_DTS := armada-7040-db
-  IMAGE/sdcard.img.gz := boot-img-ext4 | sdcard-img-ext4 | gzip | append-metadata
+  DEVICE_VENDOR := SolidRun
+  DEVICE_MODEL := MACCHIATObin
+  DEVICE_ALT0_VENDOR := SolidRun
+  DEVICE_ALT0_MODEL := Armada 8040 Community Board
+  DEVICE_PACKAGES += kmod-i2c-core kmod-i2c-mux kmod-i2c-mux-pca954x
+  DEVICE_DTS := armada-8040-mcbin
+  SUPPORTED_DEVICES := marvell,armada8040-mcbin
 endef
-TARGET_DEVICES += marvell_armada7040-db
+TARGET_DEVICES += marvell_macchiatobin
diff --git a/target/linux/mvebu/image/cortex-a9.mk b/target/linux/mvebu/image/cortex-a9.mk
index 79253049c7..be7ec4313d 100644
--- a/target/linux/mvebu/image/cortex-a9.mk
+++ b/target/linux/mvebu/image/cortex-a9.mk
@@ -6,6 +6,34 @@
 # See /LICENSE for more information.
 #
 
+define Device/cznic_turris-omnia
+  DEVICE_VENDOR := CZ.NIC
+  DEVICE_MODEL := Turris Omnia
+  KERNEL_INSTALL := 1
+  KERNEL := kernel-bin
+  KERNEL_INITRAMFS := kernel-bin
+  DEVICE_PACKAGES :=  \
+    mkf2fs e2fsprogs kmod-fs-vfat kmod-nls-cp437 kmod-nls-iso8859-1 \
+    wpad-basic kmod-ath9k kmod-ath10k-ct ath10k-firmware-qca988x-ct \
+    partx-utils kmod-i2c-core kmod-i2c-mux kmod-i2c-mux-pca954x
+  IMAGES := $$(IMAGE_PREFIX)-sysupgrade.img.gz omnia-medkit-$$(IMAGE_PREFIX)-initramfs.tar.gz
+  IMAGE/$$(IMAGE_PREFIX)-sysupgrade.img.gz := boot-img | sdcard-img | gzip | append-metadata
+  IMAGE/omnia-medkit-$$(IMAGE_PREFIX)-initramfs.tar.gz := omnia-medkit-initramfs | gzip
+  IMAGE_NAME = $$(2)
+  SOC := armada-385
+  SUPPORTED_DEVICES += armada-385-turris-omnia
+endef
+TARGET_DEVICES += cznic_turris-omnia
+
+define Device/globalscale_mirabox
+  $(Device/NAND-512K)
+  DEVICE_VENDOR := Globalscale
+  DEVICE_MODEL := Mirabox
+  SOC := armada-370
+  SUPPORTED_DEVICES += mirabox
+endef
+TARGET_DEVICES += globalscale_mirabox
+
 define Device/linksys
   $(Device/NAND-128K)
   DEVICE_VENDOR := Linksys
@@ -25,29 +53,6 @@ define Device/linksys_wrt1200ac
 endef
 TARGET_DEVICES += linksys_wrt1200ac
 
-define Device/linksys_wrt1900acv2
-  $(call Device/linksys)
-  DEVICE_MODEL := WRT1900AC
-  DEVICE_VARIANT := v2
-  DEVICE_ALT0_VENDOR := Linksys
-  DEVICE_ALT0_MODEL := Cobra
-  DEVICE_DTS := armada-385-linksys-cobra
-  DEVICE_PACKAGES += mwlwifi-firmware-88w8864
-  SUPPORTED_DEVICES := armada-385-linksys-cobra linksys,cobra
-endef
-TARGET_DEVICES += linksys_wrt1900acv2
-
-define Device/linksys_wrt3200acm
-  $(call Device/linksys)
-  DEVICE_MODEL := WRT3200ACM
-  DEVICE_ALT0_VENDOR := Linksys
-  DEVICE_ALT0_MODEL := Rango
-  DEVICE_DTS := armada-385-linksys-rango
-  DEVICE_PACKAGES += kmod-btmrvl kmod-mwifiex-sdio mwlwifi-firmware-88w8964
-  SUPPORTED_DEVICES := armada-385-linksys-rango linksys,rango
-endef
-TARGET_DEVICES += linksys_wrt3200acm
-
 define Device/linksys_wrt1900acs
   $(call Device/linksys)
   DEVICE_MODEL := WRT1900ACS
@@ -63,18 +68,17 @@ define Device/linksys_wrt1900acs
 endef
 TARGET_DEVICES += linksys_wrt1900acs
 
-define Device/linksys_wrt32x
+define Device/linksys_wrt1900acv2
   $(call Device/linksys)
-  DEVICE_MODEL := WRT32X
+  DEVICE_MODEL := WRT1900AC
+  DEVICE_VARIANT := v2
   DEVICE_ALT0_VENDOR := Linksys
-  DEVICE_ALT0_MODEL := Venom
-  DEVICE_DTS := armada-385-linksys-venom
-  DEVICE_PACKAGES += kmod-btmrvl kmod-mwifiex-sdio mwlwifi-firmware-88w8964
-  KERNEL_SIZE := 3072k
-  KERNEL := kernel-bin | append-dtb
-  SUPPORTED_DEVICES := armada-385-linksys-venom linksys,venom
+  DEVICE_ALT0_MODEL := Cobra
+  DEVICE_DTS := armada-385-linksys-cobra
+  DEVICE_PACKAGES += mwlwifi-firmware-88w8864
+  SUPPORTED_DEVICES := armada-385-linksys-cobra linksys,cobra
 endef
-TARGET_DEVICES += linksys_wrt32x
+TARGET_DEVICES += linksys_wrt1900acv2
 
 define Device/linksys_wrt1900ac
   $(call Device/linksys)
@@ -89,29 +93,29 @@ define Device/linksys_wrt1900ac
 endef
 TARGET_DEVICES += linksys_wrt1900ac
 
-define Device/plathome_openblocks-ax3-4
-  DEVICE_VENDOR := Plat'Home
-  DEVICE_MODEL := OpenBlocks AX3
-  DEVICE_VARIANT := 4 ports
-  SOC := armada-xp
-  SUPPORTED_DEVICES += openblocks-ax3-4
-  BLOCKSIZE := 128k
-  PAGESIZE := 1
-  IMAGES += factory.img
-  IMAGE/factory.img := append-kernel | pad-to $$(BLOCKSIZE) | append-ubi
+define Device/linksys_wrt3200acm
+  $(call Device/linksys)
+  DEVICE_MODEL := WRT3200ACM
+  DEVICE_ALT0_VENDOR := Linksys
+  DEVICE_ALT0_MODEL := Rango
+  DEVICE_DTS := armada-385-linksys-rango
+  DEVICE_PACKAGES += kmod-btmrvl kmod-mwifiex-sdio mwlwifi-firmware-88w8964
+  SUPPORTED_DEVICES := armada-385-linksys-rango linksys,rango
 endef
-TARGET_DEVICES += plathome_openblocks-ax3-4
+TARGET_DEVICES += linksys_wrt3200acm
 
-define Device/marvell_a385-db-ap
-  $(Device/NAND-256K)
-  DEVICE_VENDOR := Marvell
-  DEVICE_MODEL := Armada 385 Development Board AP (DB-88F6820-AP)
-  DEVICE_DTS := armada-385-db-ap
-  IMAGES += factory.img
-  KERNEL_SIZE := 8192k
-  SUPPORTED_DEVICES += armada-385-db-ap
+define Device/linksys_wrt32x
+  $(call Device/linksys)
+  DEVICE_MODEL := WRT32X
+  DEVICE_ALT0_VENDOR := Linksys
+  DEVICE_ALT0_MODEL := Venom
+  DEVICE_DTS := armada-385-linksys-venom
+  DEVICE_PACKAGES += kmod-btmrvl kmod-mwifiex-sdio mwlwifi-firmware-88w8964
+  KERNEL_SIZE := 3072k
+  KERNEL := kernel-bin | append-dtb
+  SUPPORTED_DEVICES := armada-385-linksys-venom linksys,venom
 endef
-TARGET_DEVICES += marvell_a385-db-ap
+TARGET_DEVICES += linksys_wrt32x
 
 define Device/marvell_a370-db
   $(Device/NAND-512K)
@@ -131,6 +135,27 @@ define Device/marvell_a370-rd
 endef
 TARGET_DEVICES += marvell_a370-rd
 
+define Device/marvell_a385-db-ap
+  $(Device/NAND-256K)
+  DEVICE_VENDOR := Marvell
+  DEVICE_MODEL := Armada 385 Development Board AP (DB-88F6820-AP)
+  DEVICE_DTS := armada-385-db-ap
+  IMAGES += factory.img
+  KERNEL_SIZE := 8192k
+  SUPPORTED_DEVICES += armada-385-db-ap
+endef
+TARGET_DEVICES += marvell_a385-db-ap
+
+define Device/marvell_a388-rd
+  DEVICE_VENDOR := Marvell
+  DEVICE_MODEL := Armada 388 RD (RD-88F6820-AP)
+  DEVICE_DTS := armada-388-rd
+  IMAGES := firmware.bin
+  IMAGE/firmware.bin := append-kernel | pad-to 256k | append-rootfs | pad-rootfs
+  SUPPORTED_DEVICES := armada-388-rd marvell,a385-rd
+endef
+TARGET_DEVICES += marvell_a388-rd
+
 define Device/marvell_axp-db
   $(Device/NAND-512K)
   DEVICE_VENDOR := Marvell
@@ -149,30 +174,18 @@ define Device/marvell_axp-gp
 endef
 TARGET_DEVICES += marvell_axp-gp
 
-define Device/marvell_a388-rd
-  DEVICE_VENDOR := Marvell
-  DEVICE_MODEL := Armada 388 RD (RD-88F6820-AP)
-  DEVICE_DTS := armada-388-rd
-  IMAGES := firmware.bin
-  IMAGE/firmware.bin := append-kernel | pad-to 256k | append-rootfs | pad-rootfs
-  SUPPORTED_DEVICES := armada-388-rd marvell,a385-rd
-endef
-TARGET_DEVICES += marvell_a388-rd
-
-define Device/solidrun_clearfog-pro-a1
-  DEVICE_VENDOR := SolidRun
-  DEVICE_MODEL := ClearFog Pro
-  KERNEL_INSTALL := 1
-  KERNEL := kernel-bin
-  DEVICE_PACKAGES := mkf2fs e2fsprogs partx-utils swconfig
-  IMAGES := sdcard.img.gz
-  IMAGE/sdcard.img.gz := boot-scr | boot-img-ext4 | sdcard-img-ext4 | gzip | append-metadata
-  DEVICE_DTS := armada-388-clearfog-pro armada-388-clearfog-base
-  SUPPORTED_DEVICES += armada-388-clearfog armada-388-clearfog-pro
-  UBOOT := clearfog-u-boot-spl.kwb
-  BOOT_SCRIPT := clearfog
+define Device/plathome_openblocks-ax3-4
+  DEVICE_VENDOR := Plat'Home
+  DEVICE_MODEL := OpenBlocks AX3
+  DEVICE_VARIANT := 4 ports
+  SOC := armada-xp
+  SUPPORTED_DEVICES += openblocks-ax3-4
+  BLOCKSIZE := 128k
+  PAGESIZE := 1
+  IMAGES += factory.img
+  IMAGE/factory.img := append-kernel | pad-to $$(BLOCKSIZE) | append-ubi
 endef
-TARGET_DEVICES += solidrun_clearfog-pro-a1
+TARGET_DEVICES += plathome_openblocks-ax3-4
 
 define Device/solidrun_clearfog-base-a1
   DEVICE_VENDOR := SolidRun
@@ -189,30 +202,17 @@ define Device/solidrun_clearfog-base-a1
 endef
 TARGET_DEVICES += solidrun_clearfog-base-a1
 
-define Device/globalscale_mirabox
-  $(Device/NAND-512K)
-  DEVICE_VENDOR := Globalscale
-  DEVICE_MODEL := Mirabox
-  SOC := armada-370
-  SUPPORTED_DEVICES += mirabox
-endef
-TARGET_DEVICES += globalscale_mirabox
-
-define Device/cznic_turris-omnia
-  DEVICE_VENDOR := CZ.NIC
-  DEVICE_MODEL := Turris Omnia
+define Device/solidrun_clearfog-pro-a1
+  DEVICE_VENDOR := SolidRun
+  DEVICE_MODEL := ClearFog Pro
   KERNEL_INSTALL := 1
   KERNEL := kernel-bin
-  KERNEL_INITRAMFS := kernel-bin
-  DEVICE_PACKAGES :=  \
-    mkf2fs e2fsprogs kmod-fs-vfat kmod-nls-cp437 kmod-nls-iso8859-1 \
-    wpad-basic kmod-ath9k kmod-ath10k-ct ath10k-firmware-qca988x-ct \
-    partx-utils kmod-i2c-core kmod-i2c-mux kmod-i2c-mux-pca954x
-  IMAGES := $$(IMAGE_PREFIX)-sysupgrade.img.gz omnia-medkit-$$(IMAGE_PREFIX)-initramfs.tar.gz
-  IMAGE/$$(IMAGE_PREFIX)-sysupgrade.img.gz := boot-img | sdcard-img | gzip | append-metadata
-  IMAGE/omnia-medkit-$$(IMAGE_PREFIX)-initramfs.tar.gz := omnia-medkit-initramfs | gzip
-  IMAGE_NAME = $$(2)
-  SOC := armada-385
-  SUPPORTED_DEVICES += armada-385-turris-omnia
+  DEVICE_PACKAGES := mkf2fs e2fsprogs partx-utils swconfig
+  IMAGES := sdcard.img.gz
+  IMAGE/sdcard.img.gz := boot-scr | boot-img-ext4 | sdcard-img-ext4 | gzip | append-metadata
+  DEVICE_DTS := armada-388-clearfog-pro armada-388-clearfog-base
+  SUPPORTED_DEVICES += armada-388-clearfog armada-388-clearfog-pro
+  UBOOT := clearfog-u-boot-spl.kwb
+  BOOT_SCRIPT := clearfog
 endef
-TARGET_DEVICES += cznic_turris-omnia
+TARGET_DEVICES += solidrun_clearfog-pro-a1