diff --git a/target/linux/ramips/image/Makefile b/target/linux/ramips/image/Makefile
index 1d865aa567..ca331c52c2 100644
--- a/target/linux/ramips/image/Makefile
+++ b/target/linux/ramips/image/Makefile
@@ -19,10 +19,10 @@ loadaddr-$(CONFIG_TARGET_ramips_mt7621) := 0x80001000
 
 KERNEL_LOADADDR := $(loadaddr-y)
 
-KERNEL_DTB = kernel-bin | append-dtb | lzma
+KERNEL_DTB_LZMA = kernel-bin | append-dtb | lzma
 define Device/Default
   PROFILES = Default
-  KERNEL := $(KERNEL_DTB) | uImage lzma
+  KERNEL := $(KERNEL_DTB_LZMA) | uImage lzma
   SOC := $(DEFAULT_SOC)
   DEVICE_DTS_DIR := ../dts
   DEVICE_DTS = $$(SOC)_$(1)
diff --git a/target/linux/ramips/image/common-tp-link.mk b/target/linux/ramips/image/common-tp-link.mk
index 587ef89fc1..9431928aaa 100644
--- a/target/linux/ramips/image/common-tp-link.mk
+++ b/target/linux/ramips/image/common-tp-link.mk
@@ -7,8 +7,8 @@ define Device/tplink-v1
   TPLINK_HWID :=
   TPLINK_HWREV := 0x1
   TPLINK_HEADER_VERSION := 1
-  KERNEL := $(KERNEL_DTB)
-  KERNEL_INITRAMFS := $(KERNEL_DTB) | tplink-v1-header -e -O
+  KERNEL := $(KERNEL_DTB_LZMA)
+  KERNEL_INITRAMFS := $(KERNEL_DTB_LZMA) | tplink-v1-header -e -O
   IMAGES += factory.bin
   IMAGE/factory.bin := tplink-v1-image factory -e -O
   IMAGE/sysupgrade.bin := tplink-v1-image sysupgrade -e -O | append-metadata | \
@@ -22,8 +22,8 @@ define Device/tplink-v2
   TPLINK_HWREV := 0x1
   TPLINK_HWREVADD := 0x0
   TPLINK_HVERSION := 3
-  KERNEL := $(KERNEL_DTB)
-  KERNEL_INITRAMFS := $(KERNEL_DTB) | tplink-v2-header -e
+  KERNEL := $(KERNEL_DTB_LZMA)
+  KERNEL_INITRAMFS := $(KERNEL_DTB_LZMA) | tplink-v2-header -e
   IMAGES += factory.bin
   IMAGE/factory.bin := tplink-v2-image -e
   IMAGE/sysupgrade.bin := tplink-v2-image -s -e | append-metadata | \
@@ -36,7 +36,7 @@ define Device/tplink-safeloader
   TPLINK_HWID := 0x0
   TPLINK_HWREV := 0x0
   TPLINK_HEADER_VERSION := 1
-  KERNEL := $(KERNEL_DTB) | tplink-v1-header -e -O
+  KERNEL := $(KERNEL_DTB_LZMA) | tplink-v1-header -e -O
   IMAGES += factory.bin
   IMAGE/sysupgrade.bin := append-rootfs | tplink-safeloader sysupgrade | \
 	append-metadata | check-size $$$$(IMAGE_SIZE)
diff --git a/target/linux/ramips/image/mt7620.mk b/target/linux/ramips/image/mt7620.mk
index 3512a1c55a..22a2ef467d 100644
--- a/target/linux/ramips/image/mt7620.mk
+++ b/target/linux/ramips/image/mt7620.mk
@@ -58,7 +58,7 @@ TARGET_DEVICES += alfa-network_tube-e4g
 
 define Device/amit_jboot
   DLINK_IMAGE_OFFSET := 0x10000
-  KERNEL := $(KERNEL_DTB)
+  KERNEL := $(KERNEL_DTB_LZMA)
   IMAGES += factory.bin
   IMAGE/sysupgrade.bin := mkdlinkfw | pad-rootfs | append-metadata
   IMAGE/factory.bin := mkdlinkfw | pad-rootfs | mkdlinkfw-factory
@@ -604,7 +604,7 @@ define Device/netgear_ex2700
   BLOCKSIZE := 4k
   IMAGE_SIZE := 3776k
   IMAGES += factory.bin
-  KERNEL := $(KERNEL_DTB) | uImage lzma | pad-offset 64k 64 | \
+  KERNEL := $(KERNEL_DTB_LZMA) | uImage lzma | pad-offset 64k 64 | \
 	append-uImage-fakehdr filesystem
   IMAGE/factory.bin := $$(sysupgrade_bin) | check-size $$$$(IMAGE_SIZE) | \
 	netgear-dni
@@ -650,7 +650,7 @@ define Device/netgear_wn3000rp-v3
   NETGEAR_BOARD_ID := WN3000RPv3
   BLOCKSIZE := 4k
   IMAGES += factory.bin
-  KERNEL := $(KERNEL_DTB) | uImage lzma | pad-offset 64k 64 | \
+  KERNEL := $(KERNEL_DTB_LZMA) | uImage lzma | pad-offset 64k 64 | \
 	append-uImage-fakehdr filesystem
   IMAGE/factory.bin := $$(sysupgrade_bin) | check-size $$$$(IMAGE_SIZE) | \
 	netgear-dni
diff --git a/target/linux/ramips/image/mt7621.mk b/target/linux/ramips/image/mt7621.mk
index 6d0af9d994..b9d3e81684 100644
--- a/target/linux/ramips/image/mt7621.mk
+++ b/target/linux/ramips/image/mt7621.mk
@@ -6,7 +6,7 @@ include ./common-tp-link.mk
 
 DEFAULT_SOC := mt7621
 
-KERNEL_DTB += -d21
+KERNEL_DTB_LZMA += -d21
 
 define Build/elecom-gst-factory
   $(eval product=$(word 1,$(1)))
@@ -426,7 +426,7 @@ define Device/MikroTik
   DEVICE_PACKAGES := kmod-usb3
   LOADER_TYPE := elf
   PLATFORM := mt7621
-  KERNEL := $(KERNEL_DTB) | loader-kernel
+  KERNEL := $(KERNEL_DTB_LZMA) | loader-kernel
   IMAGE/sysupgrade.bin := append-kernel | kernel2minor -s 1024 | \
 	pad-to $$$$(BLOCKSIZE) | append-rootfs | pad-rootfs | append-metadata | \
 	check-size $$$$(IMAGE_SIZE)
@@ -466,7 +466,7 @@ define Device/mtc_wr1201
   IMAGE_SIZE := 16000k
   DEVICE_VENDOR := MTC
   DEVICE_MODEL := Wireless Router WR1201
-  KERNEL_INITRAMFS := $(KERNEL_DTB) | wr1201-factory-header
+  KERNEL_INITRAMFS := $(KERNEL_DTB_LZMA) | wr1201-factory-header
   DEVICE_PACKAGES := kmod-sdhci-mt7620 kmod-mt76x2 kmod-usb3 \
 	kmod-usb-ledtrig-usbport wpad-basic
 endef
@@ -579,7 +579,7 @@ define Device/netis_wf-2881
   PAGESIZE := 2048
   FILESYSTEMS := squashfs
   IMAGE_SIZE := 129280k
-  KERNEL := $(KERNEL_DTB) | pad-offset $$(BLOCKSIZE) 64 | uImage lzma
+  KERNEL := $(KERNEL_DTB_LZMA) | pad-offset $$(BLOCKSIZE) 64 | uImage lzma
   UBINIZE_OPTS := -E 5
   IMAGE/sysupgrade.bin := append-kernel | append-ubi | append-metadata | \
 	check-size $$$$(IMAGE_SIZE)
diff --git a/target/linux/ramips/image/rt288x.mk b/target/linux/ramips/image/rt288x.mk
index 800dc553a2..b77c3094fe 100644
--- a/target/linux/ramips/image/rt288x.mk
+++ b/target/linux/ramips/image/rt288x.mk
@@ -16,7 +16,7 @@ define Device/airlink101_ar670w
   DEVICE_VENDOR := Airlink
   DEVICE_MODEL := AR670W
   IMAGE_SIZE := 3840k
-  KERNEL := $(KERNEL_DTB) | pad-to $$(BLOCKSIZE)
+  KERNEL := $(KERNEL_DTB_LZMA) | pad-to $$(BLOCKSIZE)
   IMAGES += factory.bin
   IMAGE/factory.bin := $$(sysupgrade_bin) | check-size $$$$(IMAGE_SIZE) | \
 	wrg-header wrgn16a_airlink_ar670w
@@ -83,7 +83,7 @@ define Device/dlink_dap-1522-a1
   DEVICE_MODEL := DAP-1522
   DEVICE_VARIANT := A1
   DEVICE_PACKAGES := kmod-switch-rtl8366s
-  KERNEL := $(KERNEL_DTB)
+  KERNEL := $(KERNEL_DTB_LZMA)
   IMAGES += factory.bin
   IMAGE/factory.bin := append-kernel | pad-offset $$$$(BLOCKSIZE) 96 | \
 	append-rootfs | pad-rootfs -x 96 | wrg-header wapnd01_dlink_dap1522 | \
diff --git a/target/linux/ramips/image/rt305x.mk b/target/linux/ramips/image/rt305x.mk
index f63891ac7c..7d4015e84a 100644
--- a/target/linux/ramips/image/rt305x.mk
+++ b/target/linux/ramips/image/rt305x.mk
@@ -396,7 +396,7 @@ define Device/dlink_dir-610-a1
   SOC := rt5350
   BLOCKSIZE := 4k
   SEAMA_SIGNATURE := wrgn59_dlob.hans_dir610
-  KERNEL := $(KERNEL_DTB)
+  KERNEL := $(KERNEL_DTB_LZMA)
   IMAGE_SIZE := 3776k
   DEVICE_VENDOR := D-Link
   DEVICE_MODEL := DIR-610
@@ -463,7 +463,7 @@ define Device/dlink_dwr-512-b
   DLINK_ROM_ID := DLK6E2412001
   DLINK_FAMILY_MEMBER := 0x6E24
   DLINK_FIRMWARE_SIZE := 0x7E0000
-  KERNEL := $(KERNEL_DTB)
+  KERNEL := $(KERNEL_DTB_LZMA)
   IMAGES += factory.bin
   IMAGE/sysupgrade.bin := mkdlinkfw | pad-rootfs | append-metadata
   IMAGE/factory.bin := mkdlinkfw | pad-rootfs | mkdlinkfw-factory
diff --git a/target/linux/ramips/image/rt3883.mk b/target/linux/ramips/image/rt3883.mk
index ca6a713c4d..d7d51a370d 100644
--- a/target/linux/ramips/image/rt3883.mk
+++ b/target/linux/ramips/image/rt3883.mk
@@ -85,7 +85,7 @@ define Device/samsung_cy-swr1100
   SOC := rt3662
   BLOCKSIZE := 64k
   IMAGE_SIZE := 7872k
-  KERNEL := $(KERNEL_DTB)
+  KERNEL := $(KERNEL_DTB_LZMA)
   SEAMA_SIGNATURE := wrgnd10_samsung_ss815
   DEVICE_VENDOR := Samsung
   DEVICE_MODEL := CY-SWR1100