diff --git a/target/linux/apm821xx/Makefile b/target/linux/apm821xx/Makefile
index 9ba623535ee9..9697af77bb78 100644
--- a/target/linux/apm821xx/Makefile
+++ b/target/linux/apm821xx/Makefile
@@ -9,8 +9,6 @@ BOARD:=apm821xx
 BOARDNAME:=AppliedMicro APM821xx
 CPU_TYPE:=464fp
 FEATURES:=fpu dt gpio
-MAINTAINER:=Chris Blake <chrisrblake93@gmail.com>, \
-	    Christian Lamparter <chunkeey@gmail.com>
 SUBTARGETS:=nand sata
 
 KERNEL_PATCHVER:=4.19
diff --git a/target/linux/arc770/Makefile b/target/linux/arc770/Makefile
index b5e2d54065e4..8150f147c5aa 100644
--- a/target/linux/arc770/Makefile
+++ b/target/linux/arc770/Makefile
@@ -9,7 +9,6 @@ include $(TOPDIR)/rules.mk
 ARCH:=arc
 BOARD:=arc770
 BOARDNAME:=Synopsys DesignWare ARC 770D
-MAINTAINER:=Alexey Brodkin <abrodkin@synopsys.com>
 SUBTARGETS:=generic
 
 KERNEL_PATCHVER:=4.14
diff --git a/target/linux/archs38/Makefile b/target/linux/archs38/Makefile
index be6be0472b5a..a6ac05b9dfb3 100644
--- a/target/linux/archs38/Makefile
+++ b/target/linux/archs38/Makefile
@@ -10,7 +10,6 @@ ARCH:=arc
 CPU_TYPE:=archs
 BOARD:=archs38
 BOARDNAME:=Synopsys DesignWare ARC HS38
-MAINTAINER:=Alexey Brodkin <abrodkin@synopsys.com>
 SUBTARGETS:=generic
 
 KERNEL_PATCHVER:=4.14
diff --git a/target/linux/armvirt/Makefile b/target/linux/armvirt/Makefile
index 03adf4436cfc..4a8c6b092c91 100644
--- a/target/linux/armvirt/Makefile
+++ b/target/linux/armvirt/Makefile
@@ -10,7 +10,6 @@ BOARD:=armvirt
 BOARDNAME:=QEMU ARM Virtual Machine
 FEATURES:=fpu pci rtc usb
 FEATURES+=cpiogz ext4 ramdisk squashfs targz
-MAINTAINER:=Yousong Zhou <yszhou4tech@gmail.com>
 
 KERNEL_PATCHVER:=5.4
 
diff --git a/target/linux/at91/Makefile b/target/linux/at91/Makefile
index 6c1ba11c5510..4780210f36f8 100644
--- a/target/linux/at91/Makefile
+++ b/target/linux/at91/Makefile
@@ -8,8 +8,6 @@ include $(TOPDIR)/rules.mk
 
 ARCH:=arm
 BOARD:=at91
-MAINTAINER:=Claudio Mignanti <c.mignanti@gmail.com> \
-   Sandeep Sheriker <sandeep.sheriker@gmail.com>
 BOARDNAME:=Microchip (Atmel AT91)
 FEATURES:=ext4 squashfs targz usb usbgadget ubifs
 SUBTARGETS:=sama5 sam9x
diff --git a/target/linux/ath25/Makefile b/target/linux/ath25/Makefile
index cb8b7ec1be3e..4fb082edfd67 100644
--- a/target/linux/ath25/Makefile
+++ b/target/linux/ath25/Makefile
@@ -10,7 +10,6 @@ ARCH:=mips
 BOARD:=ath25
 BOARDNAME:=Atheros AR231x/AR5312
 FEATURES:=squashfs low_mem small_flash
-MAINTAINER:=Sergey Ryazanov <ryazanov.s.a@gmail.com>
 
 KERNEL_PATCHVER:=4.14
 
diff --git a/target/linux/bcm27xx/Makefile b/target/linux/bcm27xx/Makefile
index 507690357af4..7cc2aab7009b 100644
--- a/target/linux/bcm27xx/Makefile
+++ b/target/linux/bcm27xx/Makefile
@@ -11,7 +11,6 @@ ARCH:=arm
 BOARD:=bcm27xx
 BOARDNAME:=Broadcom BCM27xx
 FEATURES:=ext4 audio usb usbgadget display gpio fpu squashfs rootfs-part boot-part
-MAINTAINER:=Álvaro Fernández Rojas <noltari@gmail.com>
 SUBTARGETS:=bcm2708 bcm2709 bcm2710 bcm2711
 
 KERNEL_PATCHVER:=4.19
diff --git a/target/linux/bcm47xx/Makefile b/target/linux/bcm47xx/Makefile
index 32c1e7d211b0..c5b5e69edad3 100644
--- a/target/linux/bcm47xx/Makefile
+++ b/target/linux/bcm47xx/Makefile
@@ -11,7 +11,6 @@ BOARD:=bcm47xx
 BOARDNAME:=Broadcom BCM47xx/53xx (MIPS)
 FEATURES:=squashfs usb
 SUBTARGETS:=generic mips74k legacy
-MAINTAINER:=Hauke Mehrtens <hauke@hauke-m.de>
 
 KERNEL_PATCHVER:=4.19
 KERNEL_TESTING_PATCHVER:=5.4
diff --git a/target/linux/bcm53xx/Makefile b/target/linux/bcm53xx/Makefile
index b63aeaa0f91e..628d422b533d 100644
--- a/target/linux/bcm53xx/Makefile
+++ b/target/linux/bcm53xx/Makefile
@@ -10,7 +10,6 @@ ARCH:=arm
 BOARD:=bcm53xx
 BOARDNAME:=Broadcom BCM47xx/53xx (ARM)
 FEATURES:=squashfs nand usb pci pcie gpio
-MAINTAINER:=Hauke Mehrtens <hauke@hauke-m.de>
 CPU_TYPE:=cortex-a9
 SUBTARGETS:=generic
 
diff --git a/target/linux/bcm63xx/Makefile b/target/linux/bcm63xx/Makefile
index b31d86bb8dad..a7f3c32fab58 100644
--- a/target/linux/bcm63xx/Makefile
+++ b/target/linux/bcm63xx/Makefile
@@ -14,7 +14,6 @@ SUBTARGETS:=generic smp
 FEATURES:=squashfs usb atm pci pcmcia usbgadget
 KERNEL_PATCHVER:=4.14
 KERNEL_TESTING_PATCHVER:=4.19
-MAINTAINER:=Jonas Gorski <jogo@openwrt.org>
 
 define Target/Description
 	Build firmware images for Broadcom based xDSL/routers
diff --git a/target/linux/cns3xxx/Makefile b/target/linux/cns3xxx/Makefile
index f21ad06248b9..4df77967bf6c 100644
--- a/target/linux/cns3xxx/Makefile
+++ b/target/linux/cns3xxx/Makefile
@@ -12,8 +12,6 @@ BOARDNAME:=Cavium Networks Econa CNS3xxx
 FEATURES:=squashfs fpu gpio pcie usb usbgadget
 CPU_TYPE:=mpcore
 CPU_SUBTYPE:=vfp
-MAINTAINER:=Felix Fietkau <nbd@nbd.name>, \
-	    Koen Vandeputte <koen.vandeputte@ncentric.com>
 KERNEL_PATCHVER:=4.19
 
 define Target/Description
diff --git a/target/linux/gemini/Makefile b/target/linux/gemini/Makefile
index 1efa2ae10f08..14e786f8bb69 100644
--- a/target/linux/gemini/Makefile
+++ b/target/linux/gemini/Makefile
@@ -11,7 +11,6 @@ BOARD:=gemini
 BOARDNAME:=Cortina Systems CS351x
 FEATURES:=squashfs pci rtc usb dt gpio display ext4 rootfs-part boot-part
 CPU_TYPE:=fa526
-MAINTAINER:=Roman Yeryomin <roman@advem.lv>
 
 KERNEL_PATCHVER:=4.19
 
diff --git a/target/linux/imx6/Makefile b/target/linux/imx6/Makefile
index 068d7ef5a4f7..2a18c4411716 100644
--- a/target/linux/imx6/Makefile
+++ b/target/linux/imx6/Makefile
@@ -12,7 +12,6 @@ BOARDNAME:=Freescale i.MX 6
 FEATURES:=audio display fpu gpio pcie rtc usb usbgadget squashfs targz nand ubifs boot-part rootfs-part
 CPU_TYPE:=cortex-a9
 CPU_SUBTYPE:=neon
-MAINTAINER:=Luka Perkov <luka@openwrt.org>
 
 KERNEL_PATCHVER:=5.4
 KERNEL_TESTING_PATCHVER:=5.4
diff --git a/target/linux/ipq40xx/Makefile b/target/linux/ipq40xx/Makefile
index 7c31bad45ff6..f39736134030 100644
--- a/target/linux/ipq40xx/Makefile
+++ b/target/linux/ipq40xx/Makefile
@@ -6,7 +6,6 @@ BOARDNAME:=Qualcomm Atheros IPQ40XX
 FEATURES:=squashfs fpu ramdisk nand
 CPU_TYPE:=cortex-a7
 CPU_SUBTYPE:=neon-vfpv4
-MAINTAINER:=John Crispin <john@phrozen.org>
 SUBTARGETS:=generic
 
 KERNEL_PATCHVER:=4.19
diff --git a/target/linux/ipq806x/Makefile b/target/linux/ipq806x/Makefile
index 42f91371c37e..2a33211726db 100644
--- a/target/linux/ipq806x/Makefile
+++ b/target/linux/ipq806x/Makefile
@@ -8,7 +8,6 @@ BOARDNAME:=Qualcomm Atheros IPQ806X
 FEATURES:=squashfs nand fpu ramdisk
 CPU_TYPE:=cortex-a15
 CPU_SUBTYPE:=neon-vfpv4
-MAINTAINER:=John Crispin <john@phrozen.org>
 SUBTARGETS:=generic
 
 KERNEL_PATCHVER:=4.19
diff --git a/target/linux/ipq807x/Makefile b/target/linux/ipq807x/Makefile
index 9c0d18399318..dab05ca2044a 100644
--- a/target/linux/ipq807x/Makefile
+++ b/target/linux/ipq807x/Makefile
@@ -4,7 +4,6 @@ ARCH:=aarch64
 BOARD:=ipq807x
 BOARDNAME:=Qualcomm Atheros IPQ807x
 FEATURES:=squashfs ramdisk source-only
-MAINTAINER:=John Crispin <john@phrozen.org>
 KERNELNAME:=Image dtbs
 CPU_TYPE:=cortex-a53
 
diff --git a/target/linux/lantiq/Makefile b/target/linux/lantiq/Makefile
index ee3e42bcb093..36e8af773f4b 100644
--- a/target/linux/lantiq/Makefile
+++ b/target/linux/lantiq/Makefile
@@ -10,7 +10,6 @@ BOARD:=lantiq
 BOARDNAME:=Lantiq
 FEATURES:=squashfs
 SUBTARGETS:=xrx200 xway xway_legacy falcon ase
-MAINTAINER:=John Crispin <john@phrozen.org>
 
 KERNEL_PATCHVER:=4.19
 
diff --git a/target/linux/layerscape/Makefile b/target/linux/layerscape/Makefile
index cfca959004a6..c44ac6c2d5e0 100644
--- a/target/linux/layerscape/Makefile
+++ b/target/linux/layerscape/Makefile
@@ -11,7 +11,6 @@ BOARDNAME:=NXP Layerscape
 KERNEL_PATCHVER:=4.14
 FEATURES:=squashfs nand usb pcie gpio fpu ubifs ext4
 SUBTARGETS:=armv8_64b armv7
-MAINTAINER:=Yangbo Lu <yangbo.lu@nxp.com>
 
 define Target/Description
 	Build firmware images for NXP Layerscape based boards.
diff --git a/target/linux/mediatek/Makefile b/target/linux/mediatek/Makefile
index 152b61bb400e..54572c1cd1f2 100644
--- a/target/linux/mediatek/Makefile
+++ b/target/linux/mediatek/Makefile
@@ -7,7 +7,6 @@ BOARD:=mediatek
 BOARDNAME:=MediaTek Ralink ARM
 SUBTARGETS:=mt7622 mt7623 mt7629
 FEATURES:=squashfs nand ramdisk fpu
-MAINTAINER:=John Crispin <john@phrozen.org>
 
 KERNEL_PATCHVER:=4.19
 KERNEL_TESTING_PATCHVER:=5.4
diff --git a/target/linux/mpc85xx/Makefile b/target/linux/mpc85xx/Makefile
index b0f92ccf26ed..4bb4d8812d1b 100644
--- a/target/linux/mpc85xx/Makefile
+++ b/target/linux/mpc85xx/Makefile
@@ -11,7 +11,6 @@ BOARD:=mpc85xx
 BOARDNAME:=Freescale MPC85xx
 CPU_TYPE:=8540
 FEATURES:=squashfs ramdisk
-MAINTAINER:=Imre Kaloz <kaloz@openwrt.org>
 SUBTARGETS:=generic p1020 p2020
 
 KERNEL_PATCHVER:=5.4
diff --git a/target/linux/mvebu/Makefile b/target/linux/mvebu/Makefile
index 1688065a5cef..c14160e677a5 100644
--- a/target/linux/mvebu/Makefile
+++ b/target/linux/mvebu/Makefile
@@ -10,7 +10,6 @@ BOARD:=mvebu
 BOARDNAME:=Marvell EBU Armada
 FEATURES:=fpu usb pci pcie gpio nand squashfs ramdisk boot-part rootfs-part
 SUBTARGETS:=cortexa9 cortexa53 cortexa72
-MAINTAINER:=Imre Kaloz <kaloz@openwrt.org>
 
 KERNEL_PATCHVER:=4.19
 
diff --git a/target/linux/mxs/Makefile b/target/linux/mxs/Makefile
index 607132937139..291322f2bdb3 100644
--- a/target/linux/mxs/Makefile
+++ b/target/linux/mxs/Makefile
@@ -12,7 +12,6 @@ BOARDNAME:=Freescale i.MX23/i.MX28
 FEATURES:=ext4 rtc usb gpio
 CPU_TYPE:=arm926ej-s
 
-MAINTAINER:=Zoltan HERPAI <wigyori@uid0.hu>
 KERNEL_PATCHVER:=5.4
 KERNELNAME:=zImage dtbs
 
diff --git a/target/linux/octeon/Makefile b/target/linux/octeon/Makefile
index aa73b0e5c044..9a1af23496f4 100644
--- a/target/linux/octeon/Makefile
+++ b/target/linux/octeon/Makefile
@@ -11,7 +11,6 @@ BOARD:=octeon
 BOARDNAME:=Cavium Networks Octeon
 FEATURES:=squashfs ramdisk pci usb
 CPU_TYPE:=octeonplus
-MAINTAINER:=John Crispin <john@phrozen.org>
 
 KERNEL_PATCHVER:=4.19
 
diff --git a/target/linux/octeontx/Makefile b/target/linux/octeontx/Makefile
index b6fa4c2ea353..19a264d986fb 100644
--- a/target/linux/octeontx/Makefile
+++ b/target/linux/octeontx/Makefile
@@ -11,8 +11,6 @@ BOARD:=octeontx
 BOARDNAME:=Octeon-TX
 FEATURES:=targz pcie gpio rtc usb fpu
 
-MAINTAINER:=Tim Harvey <tharvey@gateworks.com>
-
 KERNEL_PATCHVER:=4.14
 KERNEL_TESTING_PATCHVER:=5.4
 
diff --git a/target/linux/omap/Makefile b/target/linux/omap/Makefile
index f61696fe8bf8..285677a60e78 100644
--- a/target/linux/omap/Makefile
+++ b/target/linux/omap/Makefile
@@ -16,8 +16,6 @@ CPU_SUBTYPE:=vfpv3
 
 KERNEL_PATCHVER:=4.19
 
-MAINTAINER:=Alexander Couzens <lynxis@fe80.eu>
-
 KERNELNAME:=zImage dtbs
 
 define Target/Description
diff --git a/target/linux/oxnas/Makefile b/target/linux/oxnas/Makefile
index 2f9b9f454610..bd13e33f69e2 100644
--- a/target/linux/oxnas/Makefile
+++ b/target/linux/oxnas/Makefile
@@ -7,8 +7,6 @@ SUBTARGETS:=ox810se ox820
 FEATURES:=gpio ramdisk rtc squashfs
 DEVICE_TYPE:=nas
 
-MAINTAINER:=Daniel Golle <daniel@makrotopia.org>
-
 KERNEL_PATCHVER:=4.14
 KERNEL_TESTING_PATCHVER:=5.4
 
diff --git a/target/linux/pistachio/Makefile b/target/linux/pistachio/Makefile
index dab7f0d62b34..c13f63bd1840 100644
--- a/target/linux/pistachio/Makefile
+++ b/target/linux/pistachio/Makefile
@@ -12,7 +12,6 @@ BOARDNAME:=MIPS pistachio
 FEATURES:=fpu usb usbgadget squashfs targz nand
 CPU_TYPE:=24kc
 CPU_SUBTYPE:=24kf
-MAINTAINER:=
 
 KERNEL_PATCHVER:=4.14
 
diff --git a/target/linux/ramips/Makefile b/target/linux/ramips/Makefile
index 887b5909e461..f57d9a817dba 100644
--- a/target/linux/ramips/Makefile
+++ b/target/linux/ramips/Makefile
@@ -11,7 +11,6 @@ BOARD:=ramips
 BOARDNAME:=MediaTek Ralink MIPS
 SUBTARGETS:=mt7620 mt7621 mt76x8 rt288x rt305x rt3883
 FEATURES:=squashfs gpio
-MAINTAINER:=John Crispin <john@phrozen.org>
 
 KERNEL_PATCHVER:=4.14
 
diff --git a/target/linux/rb532/Makefile b/target/linux/rb532/Makefile
index 5aa8a6dc5565..ed901d2b479d 100644
--- a/target/linux/rb532/Makefile
+++ b/target/linux/rb532/Makefile
@@ -10,7 +10,6 @@ ARCH:=mipsel
 BOARD:=rb532
 BOARDNAME:=Mikrotik RouterBoard 532
 FEATURES:=pci targz squashfs minor nand
-MAINTAINER:=Roman Yeryomin <roman@advem.lv>
 
 KERNEL_PATCHVER:=4.14
 
diff --git a/target/linux/samsung/Makefile b/target/linux/samsung/Makefile
index 922750309620..a1d0006762d4 100644
--- a/target/linux/samsung/Makefile
+++ b/target/linux/samsung/Makefile
@@ -11,7 +11,6 @@ ARCH:=arm
 BOARD:=samsung
 BOARDNAME:=Samsung s3c24xx/s5pv210
 SUBTARGETS:=s5pv210
-MAINTAINER:=Jianhui Zhao <jianhuizhao329@gmail.com>
 
 KERNEL_PATCHVER:=4.14
 
diff --git a/target/linux/sunxi/Makefile b/target/linux/sunxi/Makefile
index e1630fb44127..fa4b17c091d4 100644
--- a/target/linux/sunxi/Makefile
+++ b/target/linux/sunxi/Makefile
@@ -12,7 +12,6 @@ BOARD:=sunxi
 BOARDNAME:=Allwinner A1x/A20/A3x/R40
 FEATURES:=fpu usb ext4 display rtc squashfs
 SUBTARGETS:=cortexa8 cortexa7 cortexa53
-MAINTAINER:=Zoltan HERPAI <wigyori@uid0.hu>
 
 KERNEL_PATCHVER:=4.19
 KERNELNAME:=zImage dtbs
diff --git a/target/linux/tegra/Makefile b/target/linux/tegra/Makefile
index db58bf53d1ff..906eb0596bf7 100644
--- a/target/linux/tegra/Makefile
+++ b/target/linux/tegra/Makefile
@@ -12,7 +12,6 @@ BOARDNAME := NVIDIA Tegra
 FEATURES := audio boot-part display ext4 fpu gpio pci pcie rootfs-part rtc squashfs usb
 CPU_TYPE := cortex-a9
 CPU_SUBTYPE := vfpv3
-MAINTAINER := Tomasz Maciej Nowak <tomek_n@o2.pl>
 
 KERNEL_PATCHVER := 4.19
 
diff --git a/target/linux/x86/Makefile b/target/linux/x86/Makefile
index 2960fe8a153d..a646e6e8a75f 100644
--- a/target/linux/x86/Makefile
+++ b/target/linux/x86/Makefile
@@ -11,7 +11,6 @@ BOARD:=x86
 BOARDNAME:=x86
 FEATURES:=squashfs ext4 vdi vmdk pcmcia targz fpu
 SUBTARGETS:=generic legacy geode 64
-MAINTAINER:=Felix Fietkau <nbd@nbd.name>
 
 KERNEL_PATCHVER:=5.4
 KERNEL_TESTING_PATCHVER:=5.4
diff --git a/target/linux/zynq/Makefile b/target/linux/zynq/Makefile
index bcd36ffe2cf2..58853f2e0b6b 100644
--- a/target/linux/zynq/Makefile
+++ b/target/linux/zynq/Makefile
@@ -12,7 +12,6 @@ BOARDNAME:=Xilinx Zynq 7000 SoCs
 FEATURES:=fpu gpio rtc usb usbgadget boot-part rootfs-part squashfs
 CPU_TYPE:=cortex-a9
 CPU_SUBTYPE:=neon
-MAINTAINER:=Jason Wu <jason.wu.misc@gmail.com>
 
 # future support SUBTARGETS: for both zynq and zynqmp
 